#ifndef MBUF_H
#define MBUF_H

#include "ara/log/logging.h"
#include "ara/rm/rm.h"
#include "driver/ascend_hal.h"
#include <vector>

namespace mbuf
{
  class MbufModule
  {
  public:
    MbufModule() = default;
    ~MbufModule() = default;
    Mbuf *fillMbuf(std::vector<uint8_t> data, uint64_t *mbufSize);
    Mbuf *fillMbuf(void *data, uint64_t *mbufSize, uint64_t dataSize);
    uint8_t *getMbufData(Mbuf **buffer, uint64_t *size);
    void init(bool areYouMbufWriter, uint32_t mbufBlockNumber = 20U, uint32_t mbufBlockSize = 1048576U);

  private:
    static bool initialized;
    poolHandle handle;
    Mbuf *pMbuf = nullptr;
    ara::log::Logger &log_{ara::log::CreateLogger("mbuf_module", "MbufModule logger", ara::log::LogLevel::kDebug)};
  };
} // namespace mbuf
#endif